'use strict';

module.exports = {
  async up(queryInterface, Sequelize) {
    const { INTEGER, DATE, STRING } = Sequelize;
    await queryInterface.createTable('orgs', {
      id: { type: INTEGER, primaryKey: true, autoIncrement: true },
      org_name: STRING(255),
      org_users: STRING(512),
      org_join_key: STRING(255),
      org_projects: STRING(512),
      otherkey: STRING(512),
      otherkeys: STRING(255),
      otherkeyc: STRING(255),
      created_at: DATE,
      updated_at: DATE,
    });
  },

  async down(queryInterface) {
    await queryInterface.dropTable('orgs');
  },
};
