'use strict';

module.exports = {
  async up(queryInterface, Sequelize) {
    const { INTEGER, STRING, DATE } = Sequelize;
    await queryInterface.createTable('tags', {
      id: { type: INTEGER, primaryKey: true, autoIncrement: true },
      project_id: INTEGER,
      mission_id: INTEGER,
      tag_name: STRING(255),
      other: STRING(255),
      color: STRING(255),
      created_at: DATE,
      updated_at: DATE,
    });
  },

  async down(queryInterface) {
    await queryInterface.dropTable('tags');
  },
};
